testdisplayinfo.c File Reference
`#include "SDL.h"`
`#include <stdio.h>`
`#include <stdlib.h>`
Include dependency graph for testdisplayinfo.c:

Go to the source code of this file.

## Functions

static void | print_mode (const char *prefix, const SDL_DisplayMode *mode)
int | main (int argc, char *argv[])

## Function Documentation

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 32 of file testdisplayinfo.c.

References dpy, SDL_Rect::h, print_mode(), rect, SDL_GetCurrentDisplayMode, SDL_GetCurrentVideoDriver, SDL_GetDesktopDisplayMode, SDL_GetDisplayBounds, SDL_GetDisplayMode, SDL_GetDisplayName, SDL_GetError, SDL_GetNumDisplayModes, SDL_GetNumVideoDisplays, SDL_Init, SDL_INIT_VIDEO, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, SDL_LogError, SDL_LogSetPriority, SDL_Quit, SDL_snprintf, SDL_Rect::w, SDL_Rect::x, and SDL_Rect::y.

{
SDL_DisplayMode mode;
int num_displays, dpy;
/* Enable standard application logging */
SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO);
/* Load the SDL library */
if (SDL_Init(SDL_INIT_VIDEO) < 0) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't initialize SDL: %s\n", SDL_GetError());
return 1;
}
SDL_Log("Using video target '%s'.\n", SDL_GetCurrentVideoDriver());
num_displays = SDL_GetNumVideoDisplays();
SDL_Log("See %d displays.\n", num_displays);
for (dpy = 0; dpy < num_displays; dpy++) {
const int num_modes = SDL_GetNumDisplayModes(dpy);
SDL_Rect rect = { 0, 0, 0, 0 };
int m;
SDL_GetDisplayBounds(dpy, &rect);
SDL_Log("%d: \"%s\" (%dx%d, (%d, %d)), %d modes.\n", dpy, SDL_GetDisplayName(dpy), rect.w, rect.h, rect.x, rect.y, num_modes);
if (SDL_GetCurrentDisplayMode(dpy, &mode) == -1) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, " CURRENT: failed to query (%s)\n", SDL_GetError());
} else {
print_mode("CURRENT", &mode);
}
if (SDL_GetDesktopDisplayMode(dpy, &mode) == -1) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, " DESKTOP: failed to query (%s)\n", SDL_GetError());
} else {
print_mode("DESKTOP", &mode);
}
for (m = 0; m < num_modes; m++) {
if (SDL_GetDisplayMode(dpy, m, &mode) == -1) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, " MODE %d: failed to query (%s)\n", m, SDL_GetError());
} else {
char prefix[64];
SDL_snprintf(prefix, sizeof (prefix), " MODE %d", m);
print_mode(prefix, &mode);
}
}
SDL_Log("\n");
}
SDL_Quit();
return 0;
}
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:119
print_mode
static void print_mode(const char *prefix, const SDL_DisplayMode *mode)
Definition: testdisplayinfo.c:21
SDL_GetDisplayMode
#define SDL_GetDisplayMode
Definition: SDL_dynapi_overrides.h:510
dpy
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display dpy)
Definition: SDL_x11sym.h:36
m
const GLfloat * m
Definition: SDL_opengl_glext.h:6092
rect
SDL_Rect rect
Definition: testrelative.c:27
SDL_GetDesktopDisplayMode
#define SDL_GetDesktopDisplayMode
Definition: SDL_dynapi_overrides.h:511
SDL_GetDisplayName
#define SDL_GetDisplayName
Definition: SDL_dynapi_overrides.h:506
SDL_DisplayMode
The structure that defines a display mode.
Definition: SDL_video.h:53
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:42
SDL_GetNumVideoDisplays
#define SDL_GetNumVideoDisplays
Definition: SDL_dynapi_overrides.h:505
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:37
SDL_Quit
#define SDL_Quit
Definition: SDL_dynapi_overrides.h:64
mode
GLenum mode
Definition: SDL_opengl_glext.h:1122
SDL_GetDisplayBounds
#define SDL_GetDisplayBounds
Definition: SDL_dynapi_overrides.h:507
SDL_LOG_PRIORITY_INFO
Definition: SDL_log.h:106
SDL_Rect::x
int x
Definition: SDL_rect.h:66
SDL_Rect::w
int w
Definition: SDL_rect.h:67
SDL_LogSetPriority
#define SDL_LogSetPriority
Definition: SDL_dynapi_overrides.h:242
SDL_GetCurrentVideoDriver
#define SDL_GetCurrentVideoDriver
Definition: SDL_dynapi_overrides.h:504
SDL_Rect::h
int h
Definition: SDL_rect.h:67
SDL_snprintf
#define SDL_snprintf
Definition: SDL_dynapi_overrides.h:46
SDL_Init
#define SDL_Init
Definition: SDL_dynapi_overrides.h:60
SDL_GetNumDisplayModes
#define SDL_GetNumDisplayModes
Definition: SDL_dynapi_overrides.h:509
SDL_GetCurrentDisplayMode
#define SDL_GetCurrentDisplayMode
Definition: SDL_dynapi_overrides.h:512
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66
SDL_Rect::y
int y
Definition: SDL_rect.h:66
SDL_INIT_VIDEO
#define SDL_INIT_VIDEO
Definition: SDL.h:77
SDL_Rect
A rectangle, with the origin at the upper left.
Definition: SDL_rect.h:64

static void print_mode | ( | const char * | prefix,
|  | const SDL_DisplayMode * | mode
| ) |  |

static

Definition at line 21 of file testdisplayinfo.c.

References SDL_DisplayMode::format, SDL_DisplayMode::h, SDL_DisplayMode::refresh_rate, SDL_GetPixelFormatName, SDL_Log, and SDL_DisplayMode::w.

Referenced by main().

{
if (!mode)
return;
SDL_Log("%s: fmt=%s w=%d h=%d refresh=%d\n",
prefix, SDL_GetPixelFormatName(mode->format),
mode->w, mode->h, mode->refresh_rate);
}
SDL_DisplayMode::w
int w
Definition: SDL_video.h:56
SDL_DisplayMode::refresh_rate
int refresh_rate
Definition: SDL_video.h:58
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:37
SDL_DisplayMode::h
int h
Definition: SDL_video.h:57
SDL_DisplayMode::format
Uint32 format
Definition: SDL_video.h:55
SDL_GetPixelFormatName
#define SDL_GetPixelFormatName
Definition: SDL_dynapi_overrides.h:283